﻿//
// NTFS - Myriadbits .NET NTFS library. 
// Fast MFT reader.
// Copyright (C) 2014 Myriadbits, Jochem Bakker
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// For more information, contact me at: info@myriadbits.com
//

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;


namespace Myriadbits.NTFS
{
	public class NTFSAttributeFilename : NTFSAttribute
	{
		public NTFSAttributeFilename(DataBuffer buffer, int offset) 
			: base(buffer, offset)
		{
		//	if ((this.Flags & 0x10000000) != 0)
		//		Debug.WriteLine(string.Format("+ {0} [{1} bytes] [{2} bytes]", this.Filename, this.AllocatedFileSize, this.RealFileSize));
		//	else
		//		Debug.WriteLine(string.Format("  {0} [{1} bytes] [{2} bytes]", this.Filename, this.AllocatedFileSize, this.RealFileSize));
		}

		public ulong ParentReference { get { return (this.GetULong(0x00) & NTFS.referenceMask); } }

		public ulong AllocatedFileSize { get { return this.GetULong(0x28); } }
		public ulong RealFileSize { get { return this.GetULong(0x30); } }
		public uint Flags { get { return this.GetUInt(0x38); } }
		public byte FilenameLength { get { return this.GetByte(0x40); } }
		public byte Namespace { get { return this.GetByte(0x41); } }
		public string Filename { get { return this.GetString(0x42, this.FilenameLength * 2); } }

		public override string ToString()
		{
			return string.Format("$FILE_NAME: {0}", this.Filename);
		}

		public ulong DataSize
		{
			get
			{
				return this.RealFileSize & 0x0000FFFFFFFFFFFF;
			}
		}
	}
}
